<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\shops;


use app\common\logic\BaseLogic;
use app\common\model\shops\ShopExpress;
use think\facade\Db;


/**
 * ShopExpress逻辑
 * Class ShopExpressLogic
 * @package app\adminapi\logic\shops
 */
class ShopExpressLogic extends BaseLogic
{

    public static function lists($params): array
    {
        $where = [];
        if(isset($params['status'])){
            $where[] = ['status', '=', $params['status']];
        }
        return ShopExpress::where($where)->select()->toArray();
    }

    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            ShopExpress::create([
                'code' => $params['code'],
                'kdn_code' => $params['kdn_code'],
                'name' => $params['name'],
                'status' => $params['status'],
                'weight' => $params['weight'],
            ]);
            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            ShopExpress::where('id', $params['id'])->update([
                'code' => $params['code'],
                'kdn_code' => $params['kdn_code'],
                'name' => $params['name'],
                'status' => $params['status'],
                'weight' => $params['weight'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public static function delete(array $params): bool
    {
        return ShopExpress::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public static function detail($params): array
    {
        return ShopExpress::findOrEmpty($params['id'])->toArray();
    }

}